#ifndef DATE_H
#define DATE_H

#include <iostream>
#include <string>
#include <ctime>
#include "interval.h"

using namespace std;

typedef long long int64;

namespace Date {

	enum Month {Jan = 1, Feb = 2, Mar = 3, Apr = 4, May = 5, Jun = 6, Jul = 7, Aug = 8, Sep = 9, Oct = 10, Nov = 11, Dec = 12};

	class Date {
		int year;
		Month month;
		int day;
		int hour, minute, second;

		void normDate();

		public:
			Date();
			Date(const Date&);
			Date(const int, const Month, const int, const int, const int, const int);
			Date(const int, const int, const int, const int, const int, const int);
			Date(const int, const Month, const int);
			Date(const int, const int, const int);

			Date& operator=(const Date&);
			bool operator<(const Date&) const;

			int getYear() const;
			int getMonth() const;
			int getDay() const;
			int getHour() const;
			int getMinute() const;
			int getSecond() const;

			Date addYear(int) const;
			Date addMonth(int) const;
			Date addDay(int) const;
			Date addHour(int) const;
			Date addMinute(int) const;
			Date addSecond(int) const;

			DateInterval getInterval(const Date&) const;
			Date addInterval(const DateInterval&) const;

			string toString(const string&) const;
			string toString() const;
	};
	
	ostream& operator<<(ostream&, const Date&);
}

#endif
