#include "interval.h"

namespace Date {
	
	DateInterval::DateInterval() {
		year = month = day = hour = minute = second = 0;
	}

	DateInterval::DateInterval(const DateInterval& other) {
		year = other.year;
		month = other.month;
		day = other.day;
		hour = other.hour;
		minute = other.minute;
		second = other.second;
	}

	DateInterval::DateInterval(int y, int m, int d, int h, int i, int s) : year(y),
																		   month(m),
																		   day(d),
																		   hour(h),
																		   minute(i),
																		   second(s)
	{ }

	DateInterval& DateInterval::operator=(const DateInterval& other) {
		if(this != &other) {
			year = other.year;
			month = other.month;
			day = other.day;
			hour = other.hour;
			minute = other.minute;
			second = other.second;
		}
		return *this;
	}

	void DateInterval::invert() {
		year *= -1;
		month *= -1;
		day *= -1;
		hour *= -1;
		minute *= -1;
		second *= -1;
	}
	
	ostream& operator<<(ostream& o, const DateInterval& interval) {
		char buf[1000];
		sprintf(buf, "[%d|%d|%d|%d|%d|%d]", interval.getYear(), interval.getMonth(), interval.getDay(), interval.getHour(), interval.getMinute(), interval.getSecond());
		o << buf;
		return o;
	}
}
