#include <iostream>
#include "date.h"
#include "interval.h"

using namespace std;

int main(int argc, char *argv[]) {
	cout << "Class Date:\n";
	Date::Date curdate;
	Date::Date constructorCopy(curdate);
	cout << "Current UTC time: " << constructorCopy.toString() << endl;

	Date::Date localDate = curdate.addHour(7);
	cout << localDate.toString("Current local time: YYYY-MMM-DD hh:mm:ss") << endl;

	Date::Date overflow(2010, Date::Feb, 30, 22, 59, 72);
	cout << "Date(2010-Feb-30 22:59:72) = " << overflow.toString() << endl;

	Date::Date futureDate = curdate.addDay(100500);
	cout << "Future date: " << futureDate.toString() << endl;;

	Date::Date pastDate = curdate.addMonth(-100);
	cout << "Past date: " << pastDate.toString() << endl;

	Date::Date myDate(1991, static_cast<Date::Month>(4), 7);
	cout << "Date without time: " << myDate.toString() << endl;

	Date::Date timeDate = Date::Date(9999, Date::Feb, -365*100, 20, 0, 7);

//timeDate = timeDate.addYear(-2);
	cout << "End: " << (timeDate).toString();



	cout << "\n\nClass DateInterval:\n";
	Date::DateInterval first = localDate.getInterval(curdate);
	cout << "local - utc: ";
	cout << first.getYear() << '-' << first.getMonth() << '-' << first.getDay() << ' ';
	cout << first.getHour() << ':' << first.getMinute() << ':' << first.getSecond() << endl;
	first = curdate.getInterval(localDate);
	cout << "utc - local: ";
	cout << first.getYear() << '-' << first.getMonth() << '-' << first.getDay() << ' ';
	cout << first.getHour() << ':' << first.getMinute() << ':' << first.getSecond() << endl;

	Date::DateInterval second(1, 2, 3, 4, 5, 6);
	Date::Date third = localDate.addInterval(second);
	cout << localDate.toString() << endl;
	cout << third.toString() << endl;

	Date::DateInterval zero = localDate.getInterval(localDate);
	cout << zero << endl;

	return 0;
}
